<template>
  <component
    :is="tag"
    class="ui-button flex items-center justify-center rounded border-2 border-solid px-4 py-3 text-center font-semibold leading-tight no-underline shadow-lg transition duration-150 ease-in-out hover:shadow-md focus:shadow-md focus:outline-none focus:ring-2 focus:ring-opacity-75 focus-visible:ring-offset-2 disabled:shadow-none disabled:hover:cursor-not-allowed disabled:hover:shadow-none motion-reduce:transition-none [&_svg:not(.loading-spinner)]:fill-current [&_svg]:size-[1.25em] [&_svg]:shrink-0"
    :class="{
      'space-x-2': !iconOnly,
      'space-x-0 px-3': iconOnly,
      'border-violet-600 focus:border-violet-700 focus:bg-violet-700 focus:ring-violet-300 not-disabled:hover:border-violet-700 not-disabled:hover:bg-violet-700 not-disabled:hover:text-white':
        !info && !success && !warning && !danger && !gray,
      'bg-violet-600 text-white':
        !info && !success && !warning && !danger && !gray && !light,
      'bg-violet-50 text-violet-700 focus:text-white':
        !info && !success && !warning && !danger && !gray && light,
      'border-blue-600 focus:border-blue-700 focus:bg-blue-700 focus:ring-blue-300 not-disabled:hover:border-blue-700 not-disabled:hover:bg-blue-700 not-disabled:hover:text-white':
        info,
      'bg-blue-600 text-white': info && !light,
      'bg-blue-50 text-blue-700 focus:text-white': info && light,
      'border-green-700 focus:border-green-800 focus:bg-green-800 focus:ring-green-400 not-disabled:hover:border-green-800 not-disabled:hover:bg-green-800 not-disabled:hover:text-white':
        success,
      'bg-green-700 text-white': success && !light,
      'bg-green-50 text-green-700 focus:text-white': success && light,
      'border-yellow-300 focus:border-yellow-400 focus:bg-yellow-400 focus:ring-yellow-200 not-disabled:hover:border-yellow-400 not-disabled:hover:bg-yellow-400 not-disabled:hover:text-yellow-900':
        warning,
      'bg-yellow-300 text-yellow-900 ': warning && !light,
      'bg-yellow-50 text-yellow-800 focus:text-yellow-900': warning && light,
      'border-red-600 focus:border-red-700 focus:bg-red-700 focus:ring-red-300 not-disabled:hover:border-red-700 not-disabled:hover:bg-red-700 not-disabled:hover:text-white':
        danger,
      'bg-red-600 text-white ': danger && !light,
      'bg-red-50 text-red-700 focus:text-white': danger && light,
      'focus:border-gray-700 focus:bg-gray-700 focus:ring-gray-400 not-disabled:hover:border-gray-700 not-disabled:hover:bg-gray-700 not-disabled:hover:text-white':
        gray,
      'border-gray-600 bg-gray-600 text-white': gray && !light,
      'border-gray-500 bg-gray-100 text-gray-600 focus:text-white':
        gray && light,
      'disabled:border-gray-300 disabled:bg-gray-50 disabled:text-gray-500':
        !loading,
      loading,
    }"
  >
    <svg
      v-if="loading"
      class="loading-spinner animate-spin-irregular fill-none stroke-current stroke-2"
      viewBox="0 0 20 20"
      role="presentation"
      aria-hidden="true"
      focusable="false"
    >
      <circle class="opacity-25" cx="10" cy="10" r="9" />
      <path d="M 10 1 A 9 9 0 0 1 19 10" />
    </svg>
    <div v-if="!loading && $slots.iconLeft" class="contents">
      <slot name="iconLeft" />
    </div>
    <span :class="iconOnly ? 'sr-only' : ''">
      <slot />
    </span>
    <slot name="iconRight" />
  </component>
</template>

<script lang="ts" setup>
defineOptions({
  name: 'UiButton',
})

defineProps({
  tag: {
    type: String,
    default: 'button',
  },
  light: {
    type: Boolean,
    default: false,
  },
  info: {
    type: Boolean,
    default: false,
  },
  success: {
    type: Boolean,
    default: false,
  },
  warning: {
    type: Boolean,
    default: false,
  },
  danger: {
    type: Boolean,
    default: false,
  },
  gray: {
    type: Boolean,
    default: false,
  },
  iconOnly: {
    type: Boolean,
    default: false,
  },
  loading: {
    type: Boolean,
    default: false,
  },
})
</script>
